/*
 * (C) Copyright 2005
 * Kyungmin Park <kyungmin.park@samsung.com>
 *
 * Configuation settings for the VPAC270 board.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/* serial printf facility takes about 2.8K */
#define CFG_PRINTF
//#undef CFG_PRINTF

/*
 * High Level Configuration Options
 * (easy to change)
 */
#define CONFIG_PXA27X		1	/* This is an PXA27X CPU    */
#define CONFIG_VPAC270		1	/* on an VPAC270 Board	    */

/*
 * select serial console configuration
 */
#define CONFIG_FFUART		1	/* we use FFUART on PXA */
#define CONFIG_BAUDRATE		38400

/*
 * Miscellaneous configurable options
 */
//#define CFG_PBSIZE		256		/* Print Buffer Size */

#undef	CFG_CLKS_IN_HZ		/* everything, incl board info, in Hz */

#define CFG_LOADADDR		0x5c010000	/* default load address */

#define CFG_HZ			3686400		/* incrementer freq: 3.6864 MHz */
//#define CFG_CPUSPEED		0x290		/* set core clock to */
#undef CFG_CPUSPEED

/*
 * Memory settings
 */
#define CFG_MSC0_VAL		0x0000FFF8
#define CFG_MDCNFG_VAL		0x00000AC9
#define CFG_MDCNFG_MASK		0x00030003
#define CFG_MDREFR_VAL		0x209BA018
#define CFG_MDMRS_VAL		0x00000000

/*
 * Board OneNAND organization
 */
#define CFG_ONENAND		/* Now, we use OneNAND */

#define ONENAND_ADDR		0x00000000	/* physical address */

#define CFG_SYNC_BURST_READ	1

/* VPAC270 OneNAND is partitioned:
 * 0x0000000 - 0x0000800	1st bootloader (1KB (code) + 1KB(dummy))
 * 0x0000800 - 0x0020000	2nd bootloader (128KB - 2KB)
 * 0x0020000 - 0x0040000	2nd bootloader (U-Boot) Env Data
 * 0x0040000 - 0x4000000	depends on application
 */

#define ONENAND_START_BLOCK	0
#define ONENAND_PAGE_SIZE	0x800		/* 2KB */
#define ONENAND_BLOCK_SIZE	0x20000		/* 128KB */

#endif	/* __CONFIG_H */
