/*
 * (C) Copyright 2004
 * Jian Zhang, Texas Instruments, jzhang@ti.com.
 *
 * (C) Copyright 2002
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Marius Groeger <mgroeger@sysgo.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <version.h>

typedef int (init_fnc_t) (void);

void start_armboot (void)
{
	uchar *buf;
#ifdef CFG_PRINTF
	serial_init();
	serial_puts(XLOADER_VERSION);
#endif
	buf =  (uchar*) CFG_LOADADDR;

	if (!onenand_read_block(buf, ONENAND_START_BLOCK))
		buf += ONENAND_BLOCK_SIZE;

	if (buf == (uchar *)CFG_LOADADDR)
		hang();

	/* go run U-Boot and never return */
#ifdef CFG_PRINTF
//  	serial_puts("Starting OS Bootloader...\n");
#endif
 	((init_fnc_t *)CFG_LOADADDR)();

	/* should never come here */
}

void hang (void)
{
	/* if board_hang() returns, hange here */
#ifdef CFG_PRINTF
	serial_puts("X-Loader hangs\n");
#endif
	for (;;);
}
